/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
	"fmt"
)

// WhatsAppTemplateCategory the model 'WhatsAppTemplateCategory'
type WhatsAppTemplateCategory string

// List of WhatsAppTemplateCategory
const (
	WhatsAppTemplateCategoryMarketing WhatsAppTemplateCategory = "MARKETING"
	WhatsAppTemplateCategoryUtility WhatsAppTemplateCategory = "UTILITY"
	WhatsAppTemplateCategoryAuthentication WhatsAppTemplateCategory = "AUTHENTICATION"
)

// All allowed values of WhatsAppTemplateCategory enum
var AllowedWhatsAppTemplateCategoryEnumValues = []WhatsAppTemplateCategory{
	"MARKETING",
	"UTILITY",
	"AUTHENTICATION",
}

func (v *WhatsAppTemplateCategory) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := WhatsAppTemplateCategory(value)
	for _, existing := range AllowedWhatsAppTemplateCategoryEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid WhatsAppTemplateCategory", value)
}

// NewWhatsAppTemplateCategoryFromValue returns a pointer to a valid WhatsAppTemplateCategory
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewWhatsAppTemplateCategoryFromValue(v string) (*WhatsAppTemplateCategory, error) {
	ev := WhatsAppTemplateCategory(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for WhatsAppTemplateCategory: valid values are %v", v, AllowedWhatsAppTemplateCategoryEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v WhatsAppTemplateCategory) IsValid() bool {
	for _, existing := range AllowedWhatsAppTemplateCategoryEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to WhatsAppTemplateCategory value
func (v WhatsAppTemplateCategory) Ptr() *WhatsAppTemplateCategory {
	return &v
}

type NullableWhatsAppTemplateCategory struct {
	value *WhatsAppTemplateCategory
	isSet bool
}

func (v NullableWhatsAppTemplateCategory) Get() *WhatsAppTemplateCategory {
	return v.value
}

func (v *NullableWhatsAppTemplateCategory) Set(val *WhatsAppTemplateCategory) {
	v.value = val
	v.isSet = true
}

func (v NullableWhatsAppTemplateCategory) IsSet() bool {
	return v.isSet
}

func (v *NullableWhatsAppTemplateCategory) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableWhatsAppTemplateCategory(val *WhatsAppTemplateCategory) *NullableWhatsAppTemplateCategory {
	return &NullableWhatsAppTemplateCategory{value: val, isSet: true}
}

func (v NullableWhatsAppTemplateCategory) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableWhatsAppTemplateCategory) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}

